## coturn 4.5.2

=== debian/changelog ===
coturn (4.5.2-3) unstable; urgency=medium

  [ Ferenc Wágner ]
  * [50ab417] Don't rely on the documentation being present for creating the DB.
    Dpkg may be configured to omit installing files under /usr/share/doc.
    Since the database schema is shipped in a private directory as well,
    switch to using that instance instead. (Closes: #985054)
  * [6f94ecb] Let the purge go through under unforeseen circumstances
  * [d8f0a0a] Let debhelper do its business before the final cleanup
  * [4033c69] Make the SQLite database writable by the turnserver user and
    group.
    File permissions alone aren't enough, the containing directory needs to
    be writable as well.
  * [81731d8] Ship the empty /var/lib/turndb directory for better
    discoverability
  * [34a2b34] Split up our autopkgtest into several tests

  [ Mészáros Mihály ]
  * [1666988] Add forwarded not-needed to
    Fix-undefinded-OPENSSL_VERSION_1_1_1.patch

 -- Mészáros Mihály <misi@majd.eu>  Wed, 24 Mar 2021 20:30:23 +0100

coturn (4.5.2-2) unstable; urgency=medium

  [ Michael Prokop ]
  * [059ff0a] debian/coturn.postrm: fix check for dpkg-statoverride on package
    removal. This fixes a regression introduced in commit b9a4a8.
    While at it, also move the statoverride removal before the account removal.
    (Closes: #981330)

  [ Ferenc Wágner ]
  * [e991e26] Enroll to basic Salsa-CI

  [ Mészáros Mihály ]
  * [3505b22] HotFix upstream undefinded OPENSSL_VERSION_1_1_1
  * [20f9a9e] Add tls test to debian autopkgtest

 -- Mészáros Mihály <misi@majd.eu>  Wed, 10 Feb 2021 22:03:27 +0100

coturn (4.5.2-1) unstable; urgency=high

  * [49df393] New upstream release (4.5.2)
    - fix null pointer dereference in case of out of memory.(by Thomas Moeller)
    - merge PR #517 (by wolmi)
      add prometheus metrics
    - merge PR #637 (by David Florness)
      Delete trailing whitespace in example configuration files
    - merge PR #631 (by Debabrata Deka)
      Add architecture ppc64le to travis build
    - merge PR #627 (by Samuel)
      Fix misleading option in doc (prometheus)
    - merge PR #643 (by tupelo-schneck)
      Allow RFC6062 TCP relay data to look like TLS
    - merge PR #655 (by plinss)
      Add support for proxy protocol V1
    - merge PR #618 (by Paul Wayper)
      Print full date and time in logs
      Add new options:
      "new-log-timestamp" and "new-log-timestamp-format"
    - merge PR #599 (by Cédric Krier)
      Do not use FIPS and remove hardcode OPENSSL_VERSION_NUMBER with LibreSSL
    - update Docker mongoDB and fix with workaround the missing systemctl
    - merge PR #660 (by Camden Narzt)
      fix compilation on macOS Big Sur
    - merge PR #546 #551 #672 (by jelmd)
      Add support of --acme-redirect <URL>
      fix acme security, redundancy, consistency
    - Disable binding request logging to avoid DoS attacks.(Breaking change!)
      Add new --log-binding option to enable binding request logging
    - Fix stale-nonce documentation. Resolves #604
    - Version numbering is changed to semver 2.0
    - Merge PR #288 (by Hristo Venev)
      pkg-config, and various cleanups in configure file
    - Add systemd notification for better systemd integration
    - Fix Issue #621 (by ycaibb)
      Null pointer dereference on tcp_client_input_handler_rfc6062data function
    - Fix Issue #600 (by ycaibb)
      use-after-free vulnerability on write_to_peerchannel function
    - Fix Issue #601 (by ycaibb)
      use-after-free vulnerability on write_client_connection function
    - Little refactoring prometheus
      Fix c++ support
      Simplify (as agreed in Issue #666)
      Remove session id/allocation labels
      Remove per session metrics. We should later add more counters.
    - Fix CVE-2020-26262 (credits: Enable-Security)
      Fix ipv6 ::1 loopback check
      Not allow allocate peer address 0.0.0.0/8 and ::/128
      For more details see the github security advisory:
      https://github.com/coturn/coturn/security/advisories/GHSA-6g6j-r9rf-cm7p
  * [f0c1753] Change coturn service type to systemd notify (Closes: #934513)
  * [f9b9547] Add libsystemd-dev to build dependency
  * [5a811b1] Update watch version to 4
  * [c0a645e] Update Debian Standards to 4.5.1
  * [e429100] Patch not-needed to forwarded to upstream
  * [bc56267] Add pkg-config to build dependency
  * [bd98206] Postrm remove dir /var/lib/turn
  * [8c58afe] Change sqlite db permissions.
    Change owner to turnserver:turnserver and mode 660 (Closes: #930097)
  * [b9a4a8b] Change config file permissions.
    Change owner to root:turnserver and mode 640 (Closes: #954379)
  * [3e85092] init.d script drop root privileges (Closes: 904415)
  * [24eb87a] Add info about binding privileged ports (Closes: #964009)
  * [136a8a2] Disable pid file creation

 -- Mészáros Mihály <misi@majd.eu>  Mon, 11 Jan 2021 20:05:38 +0100
