=== debian/tests/control ===
Depends: @
Restrictions: needs-root, allow-stderr, isolation-container
Tests: setup, udp, tcp, tls
