=== src/CMakeLists.txt ===
# Author: Kang Lin (kl222@126.com)

project(coturn)

add_subdirectory(client)
add_subdirectory(server)
add_subdirectory(apps)
