=== src/apps/CMakeLists.txt ===
# Author: Kang Lin (kl222@126.com)

add_subdirectory(common)
add_subdirectory(natdiscovery)
add_subdirectory(oauth)
add_subdirectory(peer)
add_subdirectory(relay)
add_subdirectory(rfc5769)
add_subdirectory(stunclient)
add_subdirectory(uclient)
