=== debian/changelog ===
coturn (4.6.1-2build1) plucky; urgency=medium

  * No-change rebuild against mysql-8.4 and libmysqlclient24 (LP: #2089059)

 -- Lena Voytek <lena.voytek@canonical.com>  Wed, 05 Feb 2025 15:44:18 -0500

coturn (4.6.1-2) unstable; urgency=medium

  * Team upload
  * [72b4051] gbp: Remove DEFAULT rules
  * [e8cd8e1] Use common VoIP Team name
  * [5c6af2b] Link to common team Vcs (Closes: #960919)
  * [115af22] Drop default CI config
  * [f63dcdf] Fix lintian: depends-on-obsolete-package
  * [062f3bf] Drop useless lintian overrides
  * [22048fc] d/copyright: clean up

 -- Bastian Germann <bage@debian.org>  Sat, 13 Apr 2024 13:50:36 +0000

coturn (4.6.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Dominik George <natureshadow@debian.org>  Sun, 05 Feb 2023 11:03:55 +0100

coturn (4.5.2-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * [518094e] New No-FIPS-140-mode.patch fixes build against OpenSSL 3.0
    (Closes: #995659, LP: #1967018)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Thu, 02 Jun 2022 13:36:34 +0300
